
% File: Lab01_ex_audio_octave.m
clear all; close all;

% Audio signal acquisition - recording is ALWAYS done 16 BITS MONO
fs = 8000;                % sampling frequency (samples per second):
                          % 8000, 11025, 16000, 22050, 32000, 44100, 48000, 96000
Nsec = 2;                 % number of seconds
nbits = 8;                % for writing audio data to disc
                           
disp('Press any key and to record audio'); pause
pause(1)                  % in order not to record the starting CLICK
audio=record( Nsec, fs);  % start recording, Nsec seconds
sound(audio,fs);          % listen to your recording
plot(audio,'.-'); pause   % observe samples
 
% Verification - listening, plotting
sound(audio,fs);          % play a recorded sound
x = audio; clear audio;   % copy audio, clear audio
Nx = length(x);           % get number of samples 
n = 0:Nx-1;               % indexes of samples
dt = 1/fs;                % calculate sampling period
t = dt*n;                 % calculate time stamps
figure; plot(x,'bo-'); xlabel('sample number n'); title('x(n)'); grid;
figure; plot(t,x,'b-'); xlabel('t (s)'); title('x(t)'); grid;

% Write to disc and read from disc
audiowrite('speech.wav',x,fs,'BitsPerSample',bits); % write the recording
[y,fs] = audioread('speech.wav');                   % read it from file
sound(y,fs);                                        % play it again

% Signal visualization - as before
[Ny, Nchan] = size(y);    % get number of samples and number of audio channels 
n = 0:Ny-1;               % indexes of samples
dt = 1/fs;                % calculate sampling period
t = dt*n;                 % calculate time stamps
figure; plot(y(:,1),'bo-'); xlabel('sample number n'); title('y(n)'); grid;
figure; plot(t,y(:,1),'b-'); xlabel('t (s)'); title('y(t)'); grid;
