% File Lab01_ex_discretizattion.m

clear all; close all;

T = 1;
fs1 = 1000;       fs2 = 50;          % sampling frequencies 1 & 2
dt1 = 1/fs1;      dt2 = 1/fs2;       % sampling periods 1 & 2
N1 = ceil(T/dt1); N2  = ceil(T/dt2); % numbers of samples to generate
n1  = 0:N1-1;     n2  = 0:N2-1;      % vectors of sample indexes
t1 = dt1*n1;      t2 = dt2*n2;       % vectors of sampling time moments
x1 = sin(2*pi*1*t1);                 % sinusoid repeating 1 times per second
x2 = sin(2*pi*1*t2);                 % sampled with different frequencies
    
x_min=-1.5; x_max=1.5; x_minmax=x_max-x_min;  % ADC range in Volts
Nb=3; Nq=2^Nb;                       % number of bits, number of quantization levels
dx = x_minmax/Nq;                    % width of the quantization level
x2q = dx*round(x2/dx);               % quantization of signal value 
K = fs1/fs2; x2qt = [];
for k=1:N2, x2qt = [x2qt, x2q(k)*ones(1,K) ]; end  % signal after DAC

figure; plot(t1,x1,'b-',t2,x2,'bo',t1,x2qt,'k-',t2,x2q,'r*');
xlabel('t  (s)'); title('x(t)'); grid;
legend({'CT-CV','DT-CV','CT-DV','DT-DV'},'Location','northeast');