% File lab02_ex_nmr.m
% Generation of quasi-NMR signal used for algorithm testing
clear all; close all;

SNR = 40;   % signal to noise ratio
Nx = 2^11;  % number of samples
K   = 6;    % number of components
F   = [  -0.205   -0.2     0.05    0.1      0.105    0.205  ];  % normalized frequencies f/fs
A   = [   1        0.25    1       5        0.75     1      ];  % amplitudes
d   = [   0.005    0       0       0.001    0.01     0.005  ];  % dampings
fi  = zeros(1,K);
     
% Signal generation
figure
x = zeros(1,Nx); n = 0:Nx-1;
for k=1:K
    k
    x1 = A(k) .* exp(-d(k)*n) .* exp(j*2*pi*F(k)*n);
    x = x + x1;
    subplot(211); plot(real(x1)); grid; title('LAST real( x1(n) )'); axis tight;
    subplot(212); plot(real(x));  grid; title('SUM  real( x(n)  )'); axis tight;
    xlabel('sample number'); pause
end

% Addition of additive white gaussian noise
if(0)
   xn = awgn( x, SNR, 'measured' );                                  % Matlab function
   SNR1 = 10*log10( sum( x.*conj(x) ) / sum( (xn-x).*conj(xn-x) ) ), % verification
else 
   xeng = sum( x.*conj(x) );                                            % xeng = x*x';
   noise = randn(1,Nx)+j*randn(1,Nx); neng = sum( noise.*conj(noise) ); % neng=noise*noise';
   gain = sqrt( xeng / (10^(SNR/10)*neng) );                            % from SNR definition
   xn = x + gain*noise;                                                 % adding noise
   SNR2 = 10*log10( sum( x.*conj(x) ) / sum( (xn-x).*conj(xn-x) ) ),    % verification
end

figure;
subplot(211); plot(real(xn)); grid; title('real( x(n) + noise )'); axis tight;
subplot(212); plot(imag(xn)); grid; title('imag( x(n) + noise )'); axis tight;
xlabel('sample number'); pause
