% lab03_ex_image.m - 2D DCT-II of an image: image analysis and synthsis
% Thanks to Michal Markiewicz, Computer Science Dept., Jagiellonian University, Krakow, Poland
% IMPORTANT! In Octave first load the signal package: >>pkg load signal[ENTER] 
clear all; close all;

% Read image and display it
[img,map] = imread('lena512.bmp');             % read image: lena512.bmp, earth-small.jpg
figure; imshow(img,map); title('Input image'); % display image
pause

% Convert it to black & white if image is color 
if( size(img,3)==1 ) img = double( img )/255;
else                 img = double( rgb2gray(img) )/255;
end
colormap(gray);
figure; imshow(img); title('B&W image'); pause

% Perform DCT2 of the image
coeffs = dct2( img );
maxim = max(max( abs(coeffs)) )
figure; imshow( abs(coeffs) ); title('DCT2 coefficients'); pause

% Select DCT coefficients and synthesize image only from them
K=100; c = zeros( size(coeffs) ); c(1:K,1:K) = coeffs(1:K,1:K);
img2 = idct2( c );
figure;
subplot(121); imshow(c); title('DCT2 coefficients - selected');
subplot(122); imshow(img2); title('Image synthesized'); pause

% Choose only the highest DCT coefficients
figure;
% subplot(121); imshow(img); title('Input image'); 
for k = -16 : 0
    k                               % loop index changing the threshold
    threshold = 2^k * maxim,        % calculated threshold
    c = coeffs;                     % original DCT2 coefficients
    c( abs(c) < threshold ) = 0;    % coefficients below the threshold are set to zero
    before=numel(c), after=nnz(c),  % number of: all coeffs, non-zero coeffs
    img2 = idct2( c );              % inverse DCT2: image reconstruction
    subplot(121); imshow( c ); title('DCT2 coefficients left'); 
    subplot(122); imshow( img2 ); title('Image synthesized from them'); pause
end
