% lab06_ex_dtft.m - fast DtFT computation using Chirp-Z transform and FFT 
clear all; close all;

N = 256; M = 32;        % number of signal samples, number of frequency bins
fs = 128; 				% sampling ratio (Hz)
fd = 5; fu = 9;         % down and up frequency (from-to)
df = (fu-fd)/(M-1);     % step in frequency
f = fd : df : fu;       % frequencies of interest
x = rand(1, N);			% analyzed signal, random noise [0, 1]

NM1 = N+M-1;
A = exp( -j*2*pi * fd/fs );                        % for first frequency
W = exp( -j*2*pi * ((fu-fd)/(2*(M-1))/fs) );       % for frequency step
y1 = zeros(1,NM1); k=0:N-1; y1(k+1)=((A*W.^k).^k).*x(k+1); % init of y1
k = [ 0:M-1, -(N-1):1:-1]; y2 = W.^(-k.^2);                % init of y2
Y1 = fft(y1);           % #  fast circular convolution
Y2 = fft(y2);           % #  of signals y1 and y2
Y = Y1.*Y2;             % #  
y = ifft(Y)/(N/2);      % #  
k=0:M-1; XcztN(k+1) = y(k+1) .* (W.^(k.^2));    % phase correction

n = 0:N-1; Xref=x*exp(-j*2*pi*n(:)*f/fs)/(N/2);	% reference - matrix def
error = max(abs( XcztN - Xref )),			    % error

subplot(2,1,1); plot(f,real(XcztN),'r*-'); grid on; hold on;
                plot(f,real(Xref),'bo-');
subplot(2,1,2); plot(f,imag(XcztN),'r*-'); grid on; hold on;
                plot(f,imag(Xref),'bo-');  pause
