% lab08_ex_filtering.m - IIR digital filters
clear all; close all;

% Input signal x(n) - two sinusoids: 50 and 500 Hz
fs = 2000;                    % sampling ratio
Nx = 4000;                    % number of samples
dt = 1/fs; t = dt*(0:Nx-1);   % sampling moments
%x = zeros(1,Nx); x(1) = 1;   % Kronecker delta impulse
x = sin(2*pi*50*t+pi/3) + sin(2*pi*500*t+pi/7);  % sum of 2 sines

% Digital filter coefficients [ b, a] = ?
b = [ 1, 0, 2, 0, 1 ];                            % [ b0,  b1, b2, b3, b4]
a = [ 1.0000, -3.2199, 3.9203, -2.1387, 0.4412 ]; % [a0=1, a1, a2, a3, a4]

% Different design - our future work ...
% ########################################
% ???
% ########################################

% Digital filtration: x(n) --> [ b, a ] --> y(n)
M = length(b);                     % number of {b} coefficients
N = length(a); a = a(2:N); N=N-1;  % number of {a} coeffs, remove a0=1, weight of y(n)
bx = zeros(1,M);                   % buffer for input samples x(n)
by = zeros(1,N);                   % buffer for output samples y(n)
for n = 1 : Nx                               % MAIN LOOP
    bx = [ x(n) bx(1:M-1) ];                 % put new x(n) into bx buffer
    y(n) = sum( bx .* b ) - sum( by .* a );  % do filtration, find y(n)
    by = [ y(n) by(1:N-1) ];                 % put y(n) into by buffer
end
  
% Comparison of input and output
figure;
subplot(211); plot(t,x); title('x(t)'); grid;       % input  signal x(t)
subplot(212); plot(t,y); title('y(t)'); grid;       % output signal y(t)
xlabel('t (s)'); pause
figure; % signal spectra of the second halves of samples (transients are removed)
k=Nx/2+1:Nx;  f0 = fs/(Nx/2);  f=f0*(0:Nx/2-1); 
subplot(211); plot(f,20*log10(abs(2*fft(x(k)))/(Nx/2))); title('|X(f)| (dB)'); grid; 
subplot(212); plot(f,20*log10(abs(2*fft(y(k)))/(Nx/2))); title('|Y(f)| (dB)'); grid;
xlabel('f (Hz)'); pause
