% lab08_ex_iir_design.m - template of IIR digital filter design
clear all; close all;

% Digital requirements
fs = 2000;         % sampling ratio
f1 = 400;          % minimum frequency of band-pass filter
f2 = 600;          % maximum frequency of band-pass filter
N  = 8;            % number of poles

% Analog requirements --> digital requirements
f1 = 2*fs*tan(pi*f1/fs) / (2*pi);     % f1: analog --> digital 
f2 = 2*fs*tan(pi*f2/fs) / (2*pi);     % f2: analog --> gigital
w0 = 2*pi*sqrt(f1*f2);                % center of the pass-band 
dw = 2*pi*(f2-f1);                    % width of the pass-band

% Analog filter design (using different low-pass prototypes)
%[z,p,gain] = cheb2ap(N,100);              % low-pass Chebyshev 2 prototype filter (Matlab only)
[z,p,gain] = cheby2(N,100,1,'s');          % low-pass Chebyshev 2 prototype filter (Matlab, Octave)
[z,p,gain] = lp2bpTZ(z,p,gain,w0,dw);      % frequency transformation: LP to BP
b = real(gain*poly(z)); a = real(poly(p)); % analog zeros&poles --> [b,a] coeffs
f = 0 : fs/2000 : fs;                      % frequencies of interest
H = freqs(b,a,2*pi*f);                     % frequency response of analog filter
figure; plot(f,20*log10(abs(H))); xlabel('f (Hz)'); title('Analog |H(f)| (dB)'); pause 

% Conversion of analog filter to digital
[z,p,gain] = bilinearTZ(z,p,gain,fs);      % bilinear transformation
b = real(gain*poly(z)); a = real(poly(p)); % analog zeros&poles --> [b,a] coeffs
fvtool(b,a), pause                         % displaying digital filter frequency response (Matlab only)

% Add plot of zeros & poles
% Calculate and display yourself filter frequency response, without H=freqz(b,a,...)
% Do filtration of some signals, without y=filter(b,a,x)