% lab10_ex_farrow.m
% Using Farrow filters for Lagrange signal interpolation
clear all; close all;

dx = pi/5; 
xRef = 0 : pi/1000 : 10*2*pi; yRef = sin(xRef);  % reference signal
xDec = 0 : dx : 10*2*pi;      yDec = sin(xDec);  % decimated signal

% Linear interpolation
D = 0.25; % delay
h1 = [ -1  1 ]; h1 = h1(end:-1:1);  y1 = filter(h1,1,yDec);
h0 = [  1  0 ]; h0 = h0(end:-1:1);  y0 = filter(h0,1,yDec);
yL = D*y1 + y0;
xL = xDec - dx + D*dx; 

% Quadratic interpolation
D = 0.5;
h2 = [  1/2   -1    1/2 ]; h2 = h2(end:-1:1);  y2 = filter(h2,1,yDec);
h1 = [ -1/2    0    1/2 ]; h1 = h1(end:-1:1);  y1 = filter(h1,1,yDec);
h0 = [   0     1     0  ]; h0 = h0(end:-1:1);  y0 = filter(h0,1,yDec);
yQ = D*D*y2 + D*y1 + y0;
xQ = xDec - dx + D*dx; 

% Cubic interpolation
D = 0.75;
h3 = 1/6 * [-1 +3 -3  1 ]; h3 = h3(end:-1:1);  y3 = filter(h3,1,yDec);
h2 = 1/6 * [ 3 -6  3  0 ]; h2 = h2(end:-1:1);  y2 = filter(h2,1,yDec);
h1 = 1/6 * [-2 -3 +6 -1 ]; h1 = h1(end:-1:1);  y1 = filter(h1,1,yDec);
h0 = 1/6 * [ 0  6  0  0 ]; h0 = h0(end:-1:1);  y0 = filter(h0,1,yDec);
yC = D*D*D*y3 + D*D*y2 + D*y1 + y0;
xC = xDec - 2*dx + D * dx;
 
figure; plot(xRef,yRef,'k-',xDec,yDec,'bo-',xL,yL,'gs-',xQ,yQ,'r*-',xC,yC,'mx-');
grid; legend('Ref','Decim','Lin','Quad','Cubic'); pause
