% lab10_ex_fractional_delay
% Filtering and interpolation the same time
clear all; close all;

N = 1000; M=50;                   % signal length, half of the fiter length
fs = 200; f0 = 50; fx = f0/10;    % frequencies: sampling, filter cutoff, signal

dt = 1/fs; t = dt*(0:N-1);        % time
x = sin(2*pi*fx*t);               % input signal 
n = 0 : 2*M; Nc = M;              % filter indexes, central point

figure;
for D = -0.5 : 0.1 : 0.4          % we are checking different fractional delays
    D,
    hLP = sin(2*pi*f0/fs*(n-(Nc+D)))./(pi*(n-(Nc+D)));          % low-pass filter
    if( D==0  ) hLP(Nc+1) = 2*f0/fs; end
    beta=10; w = besseli( 0, beta * sqrt(1-(n-(Nc+D)).^2/M^2) )/besseli(0,beta);
    hD = hLP .* w;                                              % h windowing
    y = conv(x,hD);               % Matlab filtering function 
    y = y( 2*M+1 : end-2*M );     % cutting transients
    if( 1 ) % filter observation
      figure;  
      subplot(221); stem(hLP,'b'); title('h(n)');
      subplot(223); plot(n,w,'bo-'); title('Window function w(n)'); grid;
      f = 0:0.25:fs/2; z = exp(-j*2*pi*f/fs); H = polyval(fliplr(hD),z); % freq response
      subplot(222); plot(f,20*log10(abs(H))); grid; xlabel('f (Hz)'); title('|(H(f))|');
      subplot(224); plot(f,unwrap(angle(H))); grid; xlabel('f (Hz)'); title('ang(H(f))');
      pause
    else  % input and output signals observation 
      ty = t(M+1:N-M)-D*dt;         % sampling times of output signal
      plot(t(M+1:N),x(M+1:N),'k-',ty,y,'o'); xlabel('t [s]'); title(' y(t)');
      axis([(M+1)*dt,1,-1.25,1.25]); grid; hold on; pause(0.5)
    end
end
