% lab10_ex_pp_spectrum.m - DFT spectra of poly-phase (PP) signal components
clear all; close all; figure;

K=5; N=K*256;                 % parameters: PP order, signal length
x=cos(2*pi/32*(0:N-1));       % analyzed signal

% Signal spectrum calculation
zer=zeros(1,N); Xsum=zer;     % initialization
z=exp(j*2*pi/N*(0:N-1));      % correction 
for k=1:K
    k
    if(1) % PP components have inserted zeros and start from the x(k) sample
       xpp = zer; xpp(k:K:N)=x(k:K:N);   % PP signal component
       Xpp = fft(xpp);                   % its DFT/FFT
       Xsum = Xsum + Xpp;                % spectrum accumulation
    else % PP components have inserted zeros and start from the x(1) sample
       xpp = zer; xpp(1:K:N)=x(k:K:N);   % PP signal component
       Xpp = fft(xpp);                   % its DFT/FFT
       Xsum = Xsum + z.^(-k).*Xpp;       % spectrum accumulation
    end
    subplot(211); stem(abs(Xpp));  title('|Xpp_k( freq index )|'); hold on;
    subplot(212); stem(abs(Xsum)); title('| Xsum( freq index )|'); pause
end