function xa = hilbertTZ1(x,M,beta)
  Nx = length(x);
% Generation of the Hilbert filter impulse response 
  n=-M:M; hH=(1-cos(pi*n))./(pi*n); hH(M+1)=0;
% Windowing using Kaiser window
  w = kaiser(2*M+1,beta)'; hH = hH .* w;
% Filtration
  xi = conv(x,hH);
% Analytic signal with synchronization and removing transient states
  xa = x(M+1:Nx-M) + j*xi(2*M+1:Nx);
end