% lab11_ex_hilbert_am.m - AM demodulation using Hilbert filter
clear all; close all;

fc = 10000;  % carrier frequency
typeAM = 1;  % 1=DSB-C, 2=DSB-SC, 3=SSB-U=USB
kA = 0.5;    % modulation index for DSB-C

% Read or generate modulating signal
[x,fs] = audioread( 'speech44100.wav', [1,1*44100] );    % samples from-to
Nx = length(x); x = x.';                                 % length, transposition 
dt=1/fs; t=dt*(0:Nx-1);                                  % time
df=1/(Nx*dt); f=df*(-Nx/2:1:Nx/2-1);                     % frequency
figure; plot(t,x); grid; xlabel('t (s)'); title('x(t)'); % plot
soundsc(x,fs); pause

% Carrier amplitude calculation
if( typeAM == 1)  a = (1+kA*x);   end
if( typeAM == 2)  a = x;          end
if( typeAM == 3)  a = hilbert(x); end
% Carrier generation with AM
if( typeAM ==1 )  y = a .* cos(2*pi*fc*t); end
if( typeAM ==2 )  y = a .* cos(2*pi*fc*t); end
if( typeAM ==3 )  y = a .* exp(j*2*pi*fc*t); y = real(y); end

% AM Demodulation of a cosine
ya = hilbert(y); % calculation of analytic signal
if( typeAM == 1) xest =  (abs(ya)-1)/kA; end
if( typeAM == 2) xest = real( ya.*exp(-j*2*pi*fc*t) ); end
if( typeAM == 3) xest = real( ya.*exp(-j*2*pi*fc*t) ); end

% Results
plot(t,x,'r',t,xest,'b'); grid; xlabel('t (s)'); title('x(t) and xest(t)');
soundsc(xest,fs)
n=1000:Nx-1000; max_err = max( abs( x(n) - xest(n) ) ), pause % error

figure; plot(f,fftshift(20*log10(abs(fft(x))/Nx))); grid; title('|X(f)|'); pause
figure; plot(f,fftshift(20*log10(abs(fft(a))/Nx))); grid; title('|A(f)|'); pause
figure; plot(f,fftshift(20*log10(abs(fft(y))/Nx))); grid; title('|Y(f)|'); pause
figure; plot(f,fftshift(20*log10(abs(fft(ya))/Nx))); grid; title('|Ya(f)|'); pause
figure; plot(f,fftshift(20*log10(abs(fft(xest))/Nx))); grid; title('|Xest(f)|'); pause
