% lab11_ex_hilbert_am2.m
% Application of Hilbert filter during signal UP and DOWN conversion in frequency
% in telecommunication systems (carrier AM modulation by a transmitted signal)
clear all; close all;

% Parameters
fs = 10000;    % sampling frequency
Nx = fs;       % number of signal samples
fx = 500;      % center frequency of SFM signal 
fc = 2000;     % carrier frequency

% Signal
dt=1/fs; t=dt*(0:Nx-1);
x = sin(2*pi*(fx*t + 250/(2*pi*5)*sin(2*pi*5*t)));
xcopy = x;
figure;
subplot(221); plot(abs(fft(x)/Nx)); title('FFT of REAL-VALUE transmitted signal');

% AM DSB-LC modulation           % Double Side Band with Large Carrier
kA = 0.25;                       % amplitude modulation width
x = (1 + kA*x).*cos(2*pi*fc*t);  % modulated signal
x = hilbert(x);                  % caculation of analytic signal
x1a = (abs(x)-1)/kA;                           % demodulation #1
x1b = x.*exp(-j*2*pi*fc*t); x1b = (x1b-1)/kA;  % demodulation #2
max_err1a = max(abs(x1a-xcopy)),               % error #1
max_err1b = max(abs(x1b-xcopy)),               % error #2

% AM DSB-SC modulation           % Double Side Band with Spressed Carrier
x = xcopy;                       % restoring signal
x = x.*cos(2*pi*fc*t);           % modulation
x = hilbert(x);                  % caculation of analytic signal
x = x.*exp(-j*2*pi*fc*t);        % demodulation
max_err2 = max(abs(x-xcopy)),    % error

% AM SSB modulation              % Single Side Band
x = xcopy;                       % restoring signal
x = hilbert(x);                  % in imag() Hilbert filter output                  
%x = real(x) + j*imag(x);        % complex signal with Upper SideBand only       
%x = real(x) - j*imag(x);        % complex signal with Lower SideBand only
subplot(223); plot(abs(fft(x)/Nx)); title('FFT after HILBERT');

% Signal processing

% TX transmitter

x = x .* exp(j*2*pi*fc*t);       % complex-value frequency up-conversion (AM)
subplot(222); plot(abs(fft(x)/Nx)); title('FFT after HILB-UP');

x = real(x);                     % leaving real-part of the result only
subplot(224); plot(abs(fft(x)/Nx)); title('FFT after HILB-UP-REAL'); pause

% RX receiver

figure;                          % starting point 
subplot(221); plot(abs(fft(x)/Nx)); title('FFT after HILB-UP-REAL');

x = hilbert( x );                % restoring imaginary part of the signal
subplot(223); plot(abs(fft(x)/Nx)); title('FFT after HILB-UP-REAL-HILB');

x = x .* exp(-j*2*pi*fc*t);      % complex-value frequency down-conversion
subplot(222); plot(abs(fft(x)/Nx)); title('FFT after HILB-UP-REAL-HILB-DOWN');

x = real(x);                     % restoring input signal (AM demod)
subplot(224); plot(abs(fft(x)/Nx)); title('FFT after HILB-UP-REAL-HILB-DOWN-REAL');

max_error = max(abs(x-xcopy)),
