% lab11_ex_hilbert_demod_primer.m - joint AM&FM signal demodulation
  clear all; close all;

  fs = 8000;                        % sampling frequency
  Nx = 8000;                        % number of samples
  dt = 1/fs; t = dt*(0:Nx-1);       % sampling period, sampling moments
  fc = 1000; Ac = 10;               % carrier frequency and amplitude
  kA = 0.5; fA = 5;                 % AM modulation: index, frequency
  kF = 200; fF = 10;                % FM modulation: index, frequency
  xA = cos(2*pi*fA*t);              % signal for AM        
  xF = cos(2*pi*fF*t);              % signal for FM
% Modulation  
  s =  Ac*(1 + kA*xA) .* cos( 2*pi*( fc*t + kF*cumsum(xF)*dt ) ); % SFM signal
% Demodulation
  sa = hilbert( s );                % analytic signal, positive frequencies
  xA_est = ( abs(sa)/Ac - 1 ) / kA;
  xF_est = ( diff( unwrap( angle( sa ) ) ) /(2*pi) - fc*dt ) / (kF*dt);
% Figures
  subplot(211); plot(t,xA,'r',t,xA_est,'b'); title('A(t)'); 
  subplot(212); plot(t(2:end),xF(2:end),'r',t(2:end),xF_est,'b'); title('f(t)'); pause
  k = round(0.25*Nx) : round(0.75*Nx);
  error_a = max( abs( xA(k) - xA_est(k) )),   % amplitude  demodulation error
  error_f = max( abs( xF(k+1) - xF_est(k) )), % frequenncy demodulation error
