% lab11_ex_hilbert_demod_primer2.m
% FIR Hilbert filter -pi/2 [rad] phase shifter - AM&FM signal demodulation
clear all; close all;

% Input signal x(n) #######################################################

fs = 2000;
Nx = 4000;
dt=1/fs; t=dt*(0:Nx-1);

AM = (1+0.5*sin(2*pi*2*t));
FM = sin(2*pi*1*t);

f0 = 500; df=250;
x = AM.*cos(2*pi*(f0*t + df*cumsum(FM*dt))); % + sin(2*pi*100*t) + sin(2*pi*500*t);
%x = cos(2*pi*500*t); % + sin(2*pi*100*t) + sin(2*pi*500*t);
figure; plot(t,x); title('x(t)'); pause

% Hilbert filter design: h  = ? ###########################################

M=200;
n = -M:M; N = 2*M+1;
h = (1-cos(pi*n)) ./ (pi*n); h(M+1) = 0;
figure; stem(n,h); title('h(n)'); pause

w = chebwin(2*M+1,100)';
h = h.*w;
figure; stem(n,h); title('hw(n)'); pause

b = h;

% Verification ############################################################

f = 0 : 1 : fs/2;
zz = exp(j*2*pi*f/fs);
H = polyval(b,zz);
HH = H .* exp(-j*2*pi*f/fs*M);
figure; plot( f, 20*log10( abs(H))); xlabel('f [Hz]'); title('|H(f)| [dB]'); grid; pause
figure; plot( f, unwrap(angle(HH))); xlabel('f [Hz]'); title('angle H(f) (rad)'); grid; pause

% Filtration x(n) --> [ b, a=1 ] --> y(n) #################################
 
  Lb = length(b);
  bx = zeros(1,Lb);
  for n = 1 : Nx
      bx = [ x(n) bx(1:Lb-1) ];
      y(n) = sum( bx .* b );
  end
  
y = y(2*M+1 : Nx  );
x = x(M+1   : Nx-M);
t = t(M+1   : Nx-M);
  
figure; plot(t,x,'b',t,y,'r'); grid; title('x(t) BLUE, y(t) RED'); pause
figure; plot(x,y,'b'); grid; xlabel('x(t)'); ylabel('y(t)'); pause

% Analytic signal calculation and signal AM&FM demodulation ###############  

% Analytic signal
z = x + j*y;

% AM demodulation
k=M+1:Nx-M;
AMest = abs(z);
figure; plot(k,AM(k),'r-',k,AMest,'b-'); grid; title('AM demodulation'); pause
figure; plot(k,AM(k)-AMest,'b-'); grid; title('AM error'); pause

% FM demodulation
zz = z(2:end) .* conj(z(1:end-1));
finst = (angle(zz)/dt) /(2*pi);  % instantaneous frequency
figure; plot( finst ); grid; title('finst(n)'); pause

FMest = (finst - f0) / df;
k=M+2:Nx-M;
figure; plot( k,FM(k),'r-',k,FMest,'b-' ); grid; title('FM demodulation'); pause
figure; plot(k,FM(k)-FMest,'b-'); grid; title('FM error'); pause
