% lab11_ex_impulse_freq_response.m
% impulse and frequency response of FIR Hilbert filter and differentiation filter
  clear all; close all;

% Generate and plot the Hilbert filter impulse response 
  M=20; n=-M:M; hH=(1-cos(pi*n))./(pi*n); hH(M+1)=0;
  figure; stem(n,hH); title('hH(n)'); xlabel('n'); grid; pause
% Generate and plot the differentiation filter impulse response 
  M=20; n=-M:M; hD=cos(pi*n)./n; hD(M+1)=0;
  figure; stem(n,hD); title('hD(n)'); xlabel('n'); grid; pause
% Our choice: hH or hD   
  h = hD;
% Windowing
  w = blackman(2*M+1)'; figure; stem(w); title('w(n)'); pause,
  h = h .* w;           figure; stem(h); title('hw(n)'); pause 
% Calculate filter frequency response::
  Om = 0 : pi/1000 : pi; z=exp(-j*Om); H=polyval(h(end:-1:1),z);
% Plot its magnitude and phase response:
  figure; plot(Om,abs(H)); title('abs( H(Omega) )'); grid; pause
  figure; plot(Om,unwrap(angle(H))); title('angle( H(Omega) )'); grid; pause
% Correct the phase shift resulting from impulse response shift by M samples right
  figure; plot(Om,unwrap( angle( H.*exp(j*Om*M) ) )); title('angle( H(Omega) )'); grid; pause
