function [Om, D]=fHilbert(x,W)
% x = A*cos(Om*n+p).*exp(-n*D)
% W window 1-Hanning, 2-Blackman

N = length(x);
if(W==1) win = hanning(N)'; end       % window choice
if(W==2) win = blackman(N)'; end      %
Xh = hilbert(win.*x)./win;            % Hilbert filter/transform
Om = diff( unwrap( angle(Xh) ) );     % angle differentiation 
D = -diff( log(abs(Xh)) );            % logarithm of abs(), differentiation
ind = round( N/2-N/4 : N/2+N/4 );     % removing begin/end transients
Om = mean(Om(ind));                   % radial frequency
D = mean(D(ind));                     % damping
% temp = polyfit(ind,log(abs(Xh(ind))),1); D=-temp(1);
