function [Om, D] = fMatPen(x,K)
% x - analyzed signal  sum of damped sinusoids
% K - assumed number of real damped sine components
M = 2*K;                               % number of complex components
N = length(x);                         % number of signal samples
L = floor(N/3);                        % linear prediction order L = N/3
X = hankel(x(1:N-L),x(N-L:N));         % building Hankel matrix
X0 = X(:,1:L); X1 = X(:,2:L+1);        % cutting matrices X0 and X1
[U,S,V] = svd(X1, 0); S = diag(S);                               % SVD of X1
p = log( eig( diag(1./S(1:M)) * ((U(:,1:M)'*X0)*V(:,1:M)) ) );   % EVD of X0
Om = imag(p); [Om indx] = sort( Om, 'ascend' );  Om=Om(K+1:2*K); % pulsation
D = real(p(indx(K+1:2*K)));                                      % damping
  