% lab13_ex_model.m - signal model: mixture of multiple damped cosines
clear all; close all;

SNR = 120;                                     % signal-to-noise ratio

% One damped sine component - testing equations
N = 100; n = 0:N-1; n=n';                      % number of signal samples
A = 10; D = 0.1; Om = 0.5; phi = 0.2;          % values of signal parameters
x = A*exp(-D*n) .* cos(Om*n+phi);              % first signal equation (A,D,Om,phi)
figure; plot(x); title('Single-damped'); pause % signal shape

c = A/2 * exp(j*phi);                          % c value
lamb = exp(-D+j*Om);                           % lambda value
xm = c * lamb.^n + conj(c)*conj(lamb).^n;      % second signal equation (c,lambda)
error = max( abs( x-xm ) ),                    % error between signals x and xm
figure; plot(x-xm); pause                      % error

x = awgn( x, SNR);                             % optional noise addition
L = [ lamb.^n conj(lamb).^n ];                 % matrix generation
c = pinv( L )*x;                               % solving matrix equation
A = 2*abs(c),                                  % found A
phi = angle(c), pause                          % found phi

% Many components - at present three
A =   [ 3,     2,    1    ];                   % their: amplitudes         
D =   [ 0.1,   0.2,  0.3  ];                   % dampings
Om =  [ 0.25,  0.5,  0.75 ];                   % radial frequencies
phi = [ 0.1,   0.2,  0.3  ];                   % phase shifts
K = length(A);                                 % number of components
x = zeros(N,1);                        
L = zeros(N,2*K);
for k = 1:K                                    % signal generation
    x = x + A(k)*exp(-D(k)*n) .* cos(Om(k)*n+phi(k));
end
figure; plot(x); title('Multi-damped'); pause  % signal shape
x = awgn( x, SNR);                             % optional noise addition
[Om, D] = fMatPen(x,K), pause                  % optional Om and D calculation
for k = 1:K                                    % matrix L generation
    L(:,2*k-1) = exp(-D(k)+j*Om(k)).^n;
    L(:,2*k)   = conj( exp(-D(k)+j*Om(k)) ).^n;
end
disp('Results:');
c = pinv( L )*x;                               % solving matrix equation 
A = 2*abs(c), pi = angle(c), D, Om, pause      % results
