% lab13_ex_nmr.m - signal from nuclear magnetic resonance (NMR)
clear all; close all;

load fid1.mat                        % load data
x = name.Spectrum;                   % take signal
Nx = length(x)                       % number of samples
fs = 1000*name.SweepWidthTD2;        % sampling frequency in kHz
M = 22;                              % number of components

dt=1/fs;  t = dt*(0:Nx-1);           % time
df=fs/Nx; f = (-Nx/2:Nx/2-1)*df;     % frequency

% Signal
figure; n=1:Nx/8;
subplot(211); plot(t(n),real(x(n))); grid; title('real( x(t) )'); axis tight;
subplot(212); plot(t(n),imag(x(n))); grid; title('imag( x(t) )'); axis tight;
xlabel('t (sek)'); pause

% Spectrum
X = fftshift( fft(x)/Nx );
figure; k=7000:17000;
plot(f(k),abs(X(k)),'b'); grid; title('|H(f)|');  xlabel('f (Hz)'); axis tight;
