% lab13_ex_real_sdr.m - signals from software defined radio
% J. Yuan, M. Torlak: "Modeling and Estimation of Transient Carrier
% Frequency Offset in Wireless Transceivers", IEEE Trans. on Wireless
% Communications, vol. 13 (2014), no.7, pp.4038-4049
% In Octave load the function awgn(): >>pkg load communications[ENTER]
clear all; close all;

% Software defined radio - damped sine occuring during frequency switching                          % 5 - 30 dB
SNR = 20;  % 5-30 dB
fs = 6.25e+6; dt=1/fs; Nfft = 256; N = 2*Nfft; n=0:N-1;
A = 1; ksi = 0.1; T0  = 17e-6; f0 = 1/T0; Om0 = 2*pi*f0/fs; phi = 0;
D = ksi*Om0; Om = sqrt(1-ksi^2)*Om0;
x = A * exp( -D*n ) .* sin( Om*n + phi );
figure; plot(1e+6*(n*dt),x,'b.-'); grid; xlabel('t [\mus]'); title('Damped sine'); pause

% Noise addition
x = awgn( x, SNR, 'measured');     % in Octave: >>pkg load communications[ENTER]
figure; plot(1e+6*(n*dt),x,'b.-'); grid; xlabel('t [\mus]'); title('Damped sine in noise'); pause
