function [Cx, Nframes] = cepstrum( x )
% calculation of matrix of cepstral coefficients
  
  global Mlen Mstep Np Nc               % global parameters
  N = length(x);                        % number of signal samples
  Nframes = floor((N-Mlen)/Mstep+1);    % number of frames of samples
  m = 1:Nc; w = 1 + Np*sin(pi*m/Nc)/2;  % weighting coefficients
  x = x - 0.9375*[0; x(1:N-1)];         % initial filtration (pre-emphasis)
  Cx = [];                              % initialization
% MAIN LOOP
  for  nr = 1 : Nframes
      % Taking a new frame (block) of speech samples
        n = 1+(nr-1)*Mstep : Mlen + (nr-1)*Mstep; bx = x(n);
      % Initial pre-processing
        bx = bx - mean(bx);             % remove mean value
        bx = bx .* hamming(Mlen);       % multiply with window function
      % Calculation of cepstral coefficients from prediction filter coeffs
        for k = 0 : Np                                        % # auto
            r(k+1) = sum( bx(1 : Mlen-k) .* bx(1+k : Mlen) ); % # correlation
        end                                                   % # samples
        rr(1:Np,1)=(r(2:Np+1))';                  % auto-correlation vector
        for m = 1 : Np                            %
            R(m,1:Np)=[r(m:-1:2) r(1:Np-(m-1))];  % auto-correlation matrix
        end                                       %
        a = inv(R)*rr; a = a';                    % coefficients of prediction filter
        a = [a zeros(1,Nc-Np)];                   % appending zeros
        c(1) = a(1);                              % calculation of cepstral coeffs
        for m = 2 : Nc                            % from LPC coefficients
            k = 1:m-1; c(m) = a(m) + sum(c(k).*a(m-k).*k/m); % cc=?
        end
      % Calculation of cepstral coefficients from speech Fourier spectrum
      % c1 = real( ifft( log( abs(fft(bx)).^2))); % do it yourself
      % c2 = rceps(bx);                           % Matlab function BAD
      % c = c1; c = c'; c = c(2:Nc+1);            % choice: c1 or c2?
      % Weighting cepstral coeffcients
        cw = c .* w;                              % multiply with weights
        Cx = [Cx;  cw];                           % storing result
    end
