% lab14_ex_lattice.m
  clear all; clf;

% LPC filter coefficients
  a = [ 1 -0.9 0.64 -0.576 ]; N=length(a); aa=a(2:N); P=N-1;
% Reflection coefficients g(i) of lattice filter
  ax(P,1:P)=aa(1:P);
  for i=P:-1:1
      g(i)=-ax(i,i);
      for j=1:i-1
         ax(i-1,j)=(ax(i,j)+g(i)*ax(i,i-j))/(1-g(i)^2);
      end
   end
   g, pause
% Filtered signal
  Nx=100; n=0:Nx-1; x=sin(2*pi*n/12+pi/4);  
% Lattice filtration
  e1=zeros(1,N);
  for n=1:Nx
     e0(N)=x(n);  
     for k=N:-1:2
        e0(k-1) = e0(k)+g(k-1)*e1(k-1);
        e1(k)   = -g(k-1)*e0(k-1)+e1(k-1);
     end
     e1=[ e0(1) e1(2:N) ];
     y(n)=e0(1);
  end
% Figures - comparison with standard filtration algorithm
  yref = filter(1,a,x);
  plot(y); title('Filter output'); pause
  plot(y-yref); title('Difference with filter(1,a,x)');
