% lab14_ex_speech_recognition
% Isolated words recognition
  clear all; close all;
  
  global Mlen Mstep Np Nc     % global parameters described below
  fs = 8000;                  % sampling frequency (Hz)
  Np = 10;                    % number of poles in prediction filter transfer function
  Nc = 12;                    % number of calculated cepstral coefficients
  trec = 2;                   % time of recording (s), 2 or 3
  twind = 30;                 % time of observation window (ms)
  tstep = 10;                 % time offset between consecutive windows (ms)
  Mlen  = (twind*0.001)*fs;   % number of window samples (in one data frame)
  Mstep = (tstep*0.001)*fs;   % number of offset samples
  
  words = {'zero'; 'one'; 'two'; 'three'; 'four'},
% words = {'start'; 'left'; 'right'; 'forward'; 'backward'; 'stop'},
% words = {'New York'; 'London'; 'Paris'; 'Berlin'; 'Warsaw'},
% words = {'John Brown'; 'Mark Smith'; 'Tom Green'; 'Betty Lewis'; 'Ann Margaret'},
  
  M = length( words );        % number of words
  
% Creating database of reference recordings
  Cref = []; CCref = [];
  for k = 1 : M
      disp( strcat('Press any key and AFTER 1 SEC say reference word: ', words(k)) ); pause
    % ref = wavrecord(trec*fs, fs, 1);        % Matlab (old): no of samples, sampling freq, 1 channel
      ref = mywavrecord(trec, fs, 1);         % Matlab (new): no of seconds, sampling freq, 1 channel       
    % ref = mywavrecord_octave(trec, fs, 1);  % Octave
      ref = silence( ref, fs );               % remove silent parts (beginning, end)
      [Cref, Nframes] = cepstrum( ref );      % calculate matrix of cepstral coeffs
      [Nrow, Ncol] = size(Cref);              % read its dimensions
      CCref(1:Nrow,1:Ncol,k)=Cref ;  Nref(k)=Nframes;  % append it to database
  end
  
% Recognition of words having reference pattern in the database
  disp('Now it is time for recognition. Press any ...'); pause
  while( input(' Recognition (1/0) ? ') == 1 )
      words
      disp( 'Press any key and AFTER 1 SEC say a word to be recognized' ); pause
    % x = wavrecord(trec*fs, fs, 1);        % Matlab (old): no of samples, sampling freq, 1 channel  
      x = mywavrecord(trec, fs, 1);         % Matlab (new): no of seconds, sampling freq, 1 channel
    % x = mywavrecord_octave(trec, fs, 1);  % Octave 
      x = silence( x, fs ); pause           % remove silent parts (beginning, end)
      Cx = cepstrum( x );                   % calculate matrix of cepstral coeffs
      num = dtw( Cx, CCref, Nref );         % dynamic type warping of matrices 
      disp( strcat( 'Recognized word: ', words(num) ) );  % recognition result
  end
