function y = silence(x, fs)
% removing silence from the beginning and from the end of recorded speech

N = length(x); n = 1 : N;               % signal length
x = x-mean(x); xn = x/max(abs(x));      % mean value removal, normalization
thres = 0.99;                           % threshold (percentage of energy)   
E = xn.^2;                              % energy of each signal sample
Eall = sum( xn.^2 );                    % energy of all signal samples
[Esort ind] = sort(E,'descend');        % sorted energy of samples
Ecum = cumsum( Esort );                 % cumulative energy of samples
Neng = max( find(thres*Eall >= Ecum) ); % find last sample > threshold
[ind dummy] = sort( n(ind(1:Neng)) );   % indexes of high-energy samples
ny = ind(1) : ind(end);                 % indexes the lowest - the highest 
y = x( ny );                            % copy only silence-free speech
if(1) % Figure for verification
  yz = zeros(N,1); yz( ny(1):ny(end),1) = y;                % append zeros
  plot(n,x,'b-',ny,y+2,'r.-'); axis([1,N,min(x),max(x)+2]); % plot in one
  grid; title('Before & After Signal Cutting'); figure(1)   % figure
end
