function  sb = analysisFB(x, M)
% M-band analysis filter bank in polyphase version

% Initialization
  load enwindow.dat; pe=enwindow'; L=length(pe);     % read MP2 prototype filter
  n=0:2*M-1;                                         % #
  for k=0:M-1                                        % # polyphase analysis matrix
      A(k+1,1:2*M) = 2*cos((pi/M)*(k+0.5).*(n-M/2)); % # dimensions: M x 2M
  end                                                % #

% Filter bank: analysis
  sb = []; bx512 = zeros(1,L);                       % initialization
  for k = 1 : length(x)/M
      bx512 = [ x(k*M:-1:(k-1)*M+1) bx512(1:L-M) ];  % M new samples into buffer
      for m = 1 : 2*M
          u(m) = sum( bx512(m:2*M:L).*pe(m:2*M:L) ); % polyphase filtration
      end
      sb32 = A*u';                                   % cosine modulation
      sb = [sb; sb32'];                              % storing the result   
  end
