% lab15_ex_filterbank_simple
% MP2 filter bank - simple version
clear all; close all;

Nmany = 2000;                            % number of audio frames
N = 512;                                 % filter length
M = 32;                                  % number of sub-bands/channels 

% Input signal
Nx = N+M*(Nmany-1);                      % number of signal samples
fs = 44100;                              % assumed sampling frequency
x = randn(1,Nx);                         % input signal 
y = zeros(1,Nx);                         % output signal
%[x,fs]= audioread('bach44100.wav',[1,Nx]); x=x';

% Filter bank matrices
p = 2*sqrt(M)*prototype(N);              % prototype filter
figure; plot(p); title('p(n)'); pause    %
pmat = ones(M,1)*p;                      % matrix with prototype in each row
[n,k] = meshgrid(0:(N-1),0:(M-1));       %
C = pmat.*cos(pi/M*(k+1/2).*(n-M/2));    % analysis  matrix with prototype
D = pmat.*cos(pi/M*(k+1/2).*(n+M/2));    % synthesis matrix with prototype
D = D';                                  %
% Checking FB frequency response
figure;
K=5; KN=K*N; f = fs/KN*(0:KN-1);
plot(f,20*log10(abs(fft(C',K*N)))); xlabel('f (Hz)'); grid; pause

% Analysis - synthesis, processing in M sub-bands
bx = zeros(1,N);
for m=1:Nmany
    bx = [ x(m*M:-1:(m-1)*M+1) bx(1:N-M) ];
    BX = C*bx';                          % analysis filter bank
  % processing in M sub-bands 
    by = D*BX;                           % synthesis filter bank  
    n1st = 1+(m-1)*M; nlast = N + (m-1)*M;
    n = n1st : 1 : nlast;
    y( n ) = y( n ) + by';
end    

% Output signal
Noffs=N-M+2; n1=1:(Nx-N)-Noffs+1; n2=Noffs:(Nx-N);
xr=x(n1); yr=y(n2);
figure; plot(n1,xr,'r',n1,yr,'b'); title('INPUT (red) OUTPUT (blue)');  pause
figure; plot(n1,xr-yr); title('Difference IN-OUT');  pause
error_dB = 10*log10( sum(xr.^2) / sum((xr-yr).^2) ), pause
