% lab16_ex_arithmetic.m
% Arithmetic encoder and decoder
 
  clear all; close all;
  
% Initialization
alphabet = [ 'a'  'b'  'c'  'd' ];  % alphabet of symbols (letters)
p  =      [ 0.6  0.1  0.1  0.2 ];   % symbol probabilities
pa =    [ 0 0.6  0.7  0.8  1.0 ];   % accumulated probability to k-th symbol
Ns = length(alphabet);              % number of symbols
  
% Coding group of symbols together (one joint code-word is calculated)
num = [ 1, 1, 4];                         % symbol numbers: 1,1,4 =a,a,d 
down = 0; up = 1;                         % pointers initialization
for k = 1 : length(num)                   % loop beginning
    range = up-down;                      % new 'range'
    up = down + range * pa( num(k)+1 );   % new 'up'
    down  = down + range * pa( num(k) );  % new 'down'
end
  
% Output bitstream = binary coded fractional number from the range [down, up)
code = 0; dv = 1/2; bits = [0];
while( ~((code >= down) & (code < up)) )
    if(code < down)
       dv = dv/2; code = code + dv; bits = [ bits 1 ];
    else
       if(code < up)
          break;
       else
          code = code - dv; bits( end ) = 0;
          dv = dv/2;
          code = code + dv; bits = [ bits 1 ];
       end
    end
end
code, bits, pause
   
% Decoding message (sequence of symbols)
pa_rev = pa(end:-1:1); alpha = [ 0 (Ns:-1:1) ]; numdecod = []; % initialization
down = 0; up = 1; range = up-down;              %
for k = length(num) : -1 : 1                    % loop beginning
    x = (code-down)/range;                      % calculate number `x'
    indx = find( pa_rev <= x ), indx = indx(1); % first x: pa_reverse <= x
    up = down + range*pa_rev( indx-1 );         % new `up'
    down  = down + range*pa_rev( indx );        % new 'down'
    range = up-down;                            % new `range'
    numdecod = [numdecod alpha(indx) ];         % number of decoded symbol
end
disp('Sent symbols'); num
disp('Received symbols'); numdecod
