% SDR_IQ_Recorder.m - using ADALM PLUTO SDR (only informative version)
clear all; close all;

% RECORDING PARAMETERS:                 % EXAMPLE: LTE IN POLAND:
fc = 803.505; % 803.505, 1850, 2655     % carrier frequency in MHz
BW = 30.72;                             % bandwidth in MHz
NumberOfFrames = 25;                    % number of blocks of samples
SamplesPerFrame = 76800;                % number of IQ samples per one block  

% SDR DEVICE INITIALIZATION
sdrdev                                  % show installed SDR devices
rxPluto = sdrrx('Pluto',...             % define recording parameters
           'RadioID','usb:0',...
           'CenterFrequency', fc * 1e+6,...
           'BasebandSampleRate', BW * 1e+6,...
           'SamplesPerFrame', SamplesPerFrame,...
           'OutputDataType','double'); 
rxLogNoOverflow = dsp.SignalSink;
rxLogDataValid  = dsp.SignalSink;

% RECORDING LOOP
samples = zeros(1,SamplesPerFrame*20);
for counter = 1 : NumberOfFrames
    [data,datavalid,overflow] = rxPluto();        % choose different SDR RX
  % Check for overflow of received samples.
    if (overflow) % dropped samples
        disp('samples dropped');
    else
        rxLogNoOverflow(data);
    end
  % TEST IT
  % Check for overflow and validity of received data.
  %     if ~(overflow) % no dropped samples
  %         if ~(datavalid) % received desired data
               rxLogDataValid(data);
               samples((counter-1)*SamplesPerFrame+1:counter*SamplesPerFrame) = double(data);
  %         end
  %     else
  %         disp('no valid data received');
  %     end
end

% STORING IQ DATA
save samples