% lab17_ex_Service_UpDown_figs.m
  clear all; close all;

  clear all; close all;
   
  m=64;
  cm_inferno=inferno(m);    % good color for color-blind persons
  cm_plasma=plasma(m);      % good color for black-and-white printing
  cm_default = cm_inferno;  %
  cm = cm_default;          % our choice
  
% ##########
% PARAMETERS
% ##########

  isignal = 1;           % signal type: 1=FM, 2=OFDM, 3=AM-real, 4=AM-complex
  ibook = 1              % 0 = colors, 1 = plasma or inferno
  
  Nx = 2000;             % number of signal samples
  fs = 2000;             % sampling frequency [Hz]
  fc = 400;              % carrier frequency [Hz]
  dfc = 0;               % carrier frequency shift [Hz]: 0, 100
  phase = 0;             % phase shift; 0, pi/4
  
  dt = 1/fs; t = dt*(0:Nx-1);
  f0 = 1/(Nx*dt); f = f0*(-Nx/2:1:Nx/2-1); 
  kk = find( f>=-fc & f<=fc );
  N1st = 1; Nlast = 400; nn = N1st : Nlast; % number of signal samples to be shown
  
% #########
% SIGNAL
% #########

  if(isignal==1) % FM
     fm = 2;                % frequency of modulating sinusoid
     df = 100;              % modulation depth
     xm = sin(2*pi*fm*t);
     x = exp( j *( 2*pi*0*t + 2*pi*df/fs*cumsum(xm) ) );
     Nstft = 128; Nshift = 4;
     what = 'FM';
  end  
  if(isignal==2) % OFDM
     fk = -100 : 50 : 100;  % frequencies of signal components
     Nk = length(fk);       % number of components
     Ak = 1 : 1 : Nk;       % their amplitudes
     pk = pi/Nk *(0:Nk-1);  % their phase shifts
     x = zeros(1,Nx);
     for k = 1:Nk
         x = x + Ak(k)*exp( j * (2*pi*fk(k)*t + pk(k)) );
     end
     Nstft = 256; Nshift = 8;
     what = 'OFDM';
  end
  if(isignal==3) % AM-real, DSB-CS
     fm = [ 50 100 ];       % frequencies of modulating sinusoids
     x = 5*sin(2*pi*fm(1)*t) + 10*sin(2*pi*fm(2)*t);
     Nstft = 256; Nshift = 8;
     what = 'AMRE';
  end  
  if(isignal==4) % AM-complex, SSB
     fm = [ 50 100 ];       % frequencies of modulating sinusoids
     x = 1*exp(j*2*pi*fm(1)*t) + 2*exp(j*2*pi*fm(2)*t);
     Nstft = 256; Nshift = 8;
     what = 'AMCX';
  end  
  f0stft = 1/(Nstft*dt); fstft = f0stft*(-Nstft/2:1:Nstft/2-1); 
  
     figure('Name','SIGNAL: Real() and Imag()');
     subplot(211); stem(t(nn),real(x(nn)),'filled'); grid; title('Real( x(t) )');
     subplot(212); stem(t(nn),imag(x(nn)),'filled'); grid; title('Imag( x(t) )'); xlabel('t [s]'); pause
     
% #########
% SPECTRUM
% #########
  
     X = fftshift( fft(x)/Nx );
     figure('Name','DFT(f) of x(t): Abs(), Real(), Imag()');
     subplot(311); stem(f, abs(X),'filled'); grid; title('Abs( X(f) )'); 
     subplot(312); stem(f,real(X),'filled'); grid; title('Real( X(f) )');
     subplot(313); stem(f,imag(X),'filled'); grid; title('Imag( X(f) )'); xlabel('f [Hz]'); pause
     
     figure('Name','|STFT(t,f)| of x(t)');
     spectrogram(x,Nstft,Nstft-Nshift,fstft,fs); title('|STFT(t,f)| of x(t)');
     axis tight; ylabel('Time (ms)'); xlabel('Frequency (kHz)');
     if(ibook==1) colormap(cm); end
     pause

 
% #########
% UP #1
% #########
  disp('Freq UP #1');
  
  car = exp( j*2*pi*fc*t );
  xUp = x .* car;
  
     XUp = fftshift( fft(xUp)/Nx );
     figure('Name','UP: |DFT(f)| after Up(.): Abs(), Real(), Imag()');
     subplot(311); stem(f, abs(XUp),'filled'); grid; title('Abs( X(f) )'); 
     subplot(312); stem(f,real(XUp),'filled'); grid; title('Real( X(f) )');
     subplot(313); stem(f,imag(XUp),'filled'); grid; title('Imag( X(f) )'); xlabel('f [Hz]'); pause
     
     figure('Name','UP: |STFT(t,f)| after Up(.)');
     spectrogram(xUp,Nstft,Nstft-Nshift,fstft,fs); title('UP: |STFT(t,f)| after Up(.)');
     axis tight; ylabel('Time (ms)'); xlabel('Frequency (kHz)');
     if(ibook==1) colormap(cm); end
     pause

  xUpReal = real( xUp );
  
     XUpReal = fftshift( fft(xUpReal)/Nx );
     figure('Name','REAL: DFT(f) after Real(.): Abs(), Real(), Imag()');
     subplot(311); stem(f, abs(XUpReal),'filled'); grid; title('Abs( X(f) )'); 
     subplot(312); stem(f,real(XUpReal),'filled'); grid; title('Real( X(f) )');
     subplot(313); stem(f,imag(XUpReal),'filled'); grid; title('Imag( X(f) )'); xlabel('f [Hz]'); pause
     figure('Name','REAL: |STFT(t,f)| after Real(.)');
     
     spectrogram(xUpReal,Nstft,Nstft-Nshift,fstft,fs); title('REAL: |STFT(t,f)| after Real(.)');
     axis tight; ylabel('Time (ms)'); xlabel('Frequency (kHz)');
     if(ibook==1) colormap(cm); end
     pause
     
% #########
% UP #2
% #########
   disp('Freq UP #2');
   
   c = cos( 2*pi*fc*t );
   s = sin( 2*pi*fc*t );
   xUpRealQuad = real(x).*c  - imag(x).*s;
   XUpRealQuad = fftshift( fft(xUpRealQuad)/Nx );
   ERROR_SIGNALS_UP_12 = max( abs( xUpReal - xUpRealQuad ) ),

     figure('Name','COMPARISON of UP1 and UP2 SPECTRA. ABS() of resultant spectra');
     subplot(211); stem(f, abs(XUpReal),'filled'); grid; title('UP1 real(exp()). Abs( X(f) )'); 
     subplot(212); stem(f, abs(XUpRealQuad),'filled'); grid; title('UP2 (cos(),-sin()). Abs( X(f) )'); pause 
     
     figure('Name','COMPARISON of UP1 and UP2 STFT');
     subplot(211); spectrogram(xUpReal,Nstft,Nstft-Nshift,fstft,fs); title('UP1 real(exp()). STFT x(t)'); 
     subplot(212); spectrogram(xUpRealQuad,Nstft,Nstft-Nshift,fstft,fs); title('UP2 (cos(),-sin()). STFT x(t)');
     axis tight; ylabel('Time (ms)'); xlabel('Frequency (kHz)');
     if(ibook==1) colormap(cm); end
     pause

% #########
% DOWN
% #########
  disp('Freq DOWN');

  c = cos( 2*pi*(fc+dfc)*t + phase);
  s = sin( 2*pi*(fc+dfc)*t + phase);

  xDownRe =  2*xUpReal.*c;
  xDownIm = -2*xUpReal.*s;
  
     XDownRe = fftshift( fft(xDownRe)/Nx );
     figure('Name','DOWNcos: DFT(f) after DownCos(.): Abs(), Real(), Imag()');
     subplot(311); stem(f, abs(XDownRe),'filled'); grid; title('Abs( X(f) )'); 
     subplot(312); stem(f,real(XDownRe),'filled'); grid; title('Real( X(f) )');
     subplot(313); stem(f,imag(XDownRe),'filled'); grid; title('Imag( X(f) )'); xlabel('f [Hz]'); pause
     
     figure('Name','DOWNcos: |STFT(f,t)| after DownCos(.)');
     spectrogram(xDownRe,Nstft,Nstft-Nshift,fstft,fs); title('DOWNcos: |STFT(f,t)| after DownCos(.)');
     axis tight; ylabel('Time (ms)'); xlabel('Frequency (Hz)');
     if(ibook==1) colormap(cm); end
     pause
     
     XDownIm = fftshift( fft(xDownIm)/Nx );
     figure('Name','DOWNsin: DFT(f) after DownSin(.): Abs(), Real(), Imag()');
     subplot(311); stem(f, abs(XDownIm),'filled'); grid; title('Abs( X(f) )'); 
     subplot(312); stem(f,real(XDownIm),'filled'); grid; title('Real( X(f) )');
     subplot(313); stem(f,imag(XDownIm),'filled'); grid; title('Imag( X(f) )'); xlabel('f [Hz]'); pause
     
     figure('Name','DOWNsin: |STFT(f,t)| after DownSin(.)');
     spectrogram(xDownIm,Nstft,Nstft-Nshift,fstft,fs); title('DOWNsin: |STFT(f,t)| after DownSin(.)');
     axis tight; ylabel('Time (ms)'); xlabel('Frequency (kHz)');
     if(ibook==1) colormap(cm); end 
     pause
     
  xDown = xDownRe + j*xDownIm;
  XDown = fftshift( fft(xDown)/Nx );
 
     figure('Name','DOWN: DFT(f) after Down(.): Abs(), Real(), Imag()');
     subplot(311); stem(f, abs(XDown),'filled'); grid; title('Abs( X(f) )'); 
     subplot(312); stem(f,real(XDown),'filled'); grid; title('Real( X(f) )');
     subplot(313); stem(f,imag(XDown),'filled'); grid; title('Imag( X(f) )'); xlabel('f [Hz]'); pause
     
     figure('Name','DOWN: |STFT(f,t)| after Down(.)');
     spectrogram(xDown,Nstft,Nstft-Nshift,fstft,fs); title('DOWN: |STFT(f,t)| after Down(.)');
     axis tight; ylabel('Time (ms)'); xlabel('Frequency (kHz)');
     if(ibook==1) colormap(cm); end
     pause

   ERROR_SPECTRUM_UP_DOWN = max( abs( X(kk) - XDown(kk) ) ), pause
     
% ##############
% LowPass Filter
% ##############

  if(1) % Ideal filtering in frequency domain
     XDownFilt = zeros(1,Nx);
     XDownFilt(kk) = XDown(kk);
     xDownFilt = ifft( fftshift( XDownFilt ) )*Nx;
  else  % Practical filtering as weighted averaging
     h = fir1(51, fc/(fs/2));
     xDownFilt = filter(h, 1, xDown);
  end
  
     XDownFilt = fftshift( fft(xDownFilt)/Nx );
     figure('Name','FILTER: DFT(f) after Filter(.): Abs(), Real(), Imag()');
     subplot(311); stem(f, abs(XDownFilt),'filled'); grid; title('Abs( X(f) )'); 
     subplot(312); stem(f,real(XDownFilt),'filled'); grid; title('Real( X(f) )');
     subplot(313); stem(f,imag(XDownFilt),'filled'); grid; title('Imag( X(f) )'); xlabel('f [Hz]'); pause
     
     figure('Name','FILTER: |STFT(f,t)| after Filter(.)');
     spectrogram(xDownFilt,Nstft,Nstft-Nshift,fstft,fs); title('FILTER: |STFT(f,t)| after Filter(.)');
     axis tight; ylabel('Time (ms)'); xlabel('Frequency (kHz)');
     if(ibook==1) colormap(cm); end
     pause

  ERROR_SPECTRUM_UP_DOWN_FILTERED = max( abs( X - XDownFilt ) ),
  ERROR_SIGNAL_UP_DOWN_FILTERED = max( abs( x - xDownFilt ) ), pause
  
% Correction
  
  xDownFiltCorrect = xDownFilt .* exp( j*(2*pi*dfc*t+phase) );
  XDownFiltCorrect = fftshift( fft(xDownFiltCorrect)/Nx );
  
  ERROR_SPECTRUM_UP_DOWN_FILTERED_CORRECTED = max( abs( X - XDownFiltCorrect ) ),
  ERROR_SIGNAL_UP_DOWN_FILTERED_CORRECTED = max( abs( x - xDownFiltCorrect ) ),
  
     figure('Name','SPECTRUM of CORRECTED LowPass FILTERED Down: Abs(), Real(), Imag()');
     subplot(311); stem(f, abs(XDownFiltCorrect),'filled'); grid; title('Abs( X(f) )'); 
     subplot(312); stem(f,real(XDownFiltCorrect),'filled'); grid; title('Real( X(f) )');
     subplot(313); stem(f,imag(XDownFiltCorrect),'filled'); grid; title('Imag( X(f) )'); xlabel('f [Hz]'); pause
    
     figure('Name','SPECTROGRAM of CORRECTED LowPass FILTERED Down');
     spectrogram(xDownFiltCorrect,Nstft,Nstft-Nshift,fstft,fs); title('STFT x(t)'); pause
     axis tight; xlabel('Time (ms)'); ylabel('Frequency (kHz)');
     if(ibook==1) colormap(cm); end
     pause
