% lab17_ex_Service_UpDown_short.m
  clear all; close all;

% FM modulated signal
  Nx = 2000;                  % number of signal samples
  fs = 2000;                  % sampling frequency [Hz]
  fc = 400;                   % carrier frequency [Hz]
  fm = 2; df = 50;            % FM modulation frequency and depth
  dt = 1/fs; t = dt*(0:Nx-1); % time
  xm = sin(2*pi*fm*t);        % modulating signal
  x = exp( j *( 2*pi*0*t + 2*pi*df/fs*cumsum(xm) ) ); % FM modulated signal
  
% Frequency UP and REAL part
  c = cos( 2*pi*fc*t ); s = sin( 2*pi*fc*t );
  xUp = x .* (c + j*s);                  % Freq UP - carrier AM 
  xUpReal = real( xUp );                 % REAL part
% xUpReal = real(x).*c  - imag(x).*s;    % # quadrature modulator

% Frequency DOWN
  xDownCos =  2*xUpReal.*c;              % #
  xDownSin = -2*xUpReal.*s;              % # quadrature demodulator
  xDown = xDownCos + j*xDownSin;         % #
  
% Ideal LowPass Filter in frequency domain
  df=fs/Nx; K = floor(fc/df); 
  XDownFilt = fft(xDown);                % FFT
  XDownFilt(K+1:Nx-K) = zeros(1,Nx-2*K); % zero unwanted DFT bins 
  xDownFilt = ifft( XDownFilt );         % IFFT 

% ERROR after frequency UP & DOWN  
  ERROR_SIGNAL = max( abs( x - xDownFilt ) ), pause
