function IQn = IQupdown( IQn, fcar, fs, df, dphi )
% IQ signal frequency-UP and DOWN conversion with low-pass filtering in the RX

% Frequency UP-DOWN
N = length(IQn); n = 0:N-1;                 % signal length, sample indexes
y = real(IQn).*cos(2*pi*fcar/fs*n) - imag(IQn).*sin(2*pi*fcar/fs*n);  % UP
IQn = 2* y .* exp( -j*( 2*pi*(fcar+df)/fs*n + dphi ) );               % DOWN

% Filtering of the (2*fcar) component in the receiver
L = 250;                                             % choice of filter order
hLP = fir1(L,fcar/(fs/2),kaiser(L+1,10));            % design of filter weigths
IQn = conv( IQn, hLP ); IQn = IQn( L/2+1: end-L/2);  % low-pass filtering
