% lab20_ex_adc.m
% modeling CFO error introduced by ADC sampling frequency error and its correction

N=1000; n=0:N-1;                          % number of signal samples
fs=1e+6;                                  % sampling frequency
fc=1e+5;                                  % carrier frequency
ADCppm = 100;                             % ADC error in ppm
A = ADCppm *1e-6;                         % error scaling 
x1 = exp(j*2*pi*fc/fs*n);                 % error-free signal
x2 = exp(j*2*pi*fc/((1+A)*fs)*n);         % erroneous signal with CFO

x1c = x2 .* exp(j*2*pi*A/(1+A)*fc/fs*n);  % CFO correction
error = max( abs( x1 - x1c ) ), pause     % correction error
