% lab20_ex_figures_RX.m is included in lab20_ex_pulse_shaping.m
% Figures in the receiver

Ks = min( 20, length(IQk) );
k = 1 : Ks;
n = 1 : min( length(IQn), Ks*K );

% I(n), Q(n) in RECEIVER
disp('RECEIVER');

IQ = IQnn;

N = length(IQ); n=1:N; n2=1:round(N/2); ns = 1:K:N;
NN = min(N,Ks*K-(K-1)); nn=1:NN; kk = 1:K:NN;

figure
Nfft = round(0.75*length(IQ)); Nfft = 2 ^ floor(log2(Nfft)); fmax = fs/4;
[P, Pshift, Pzoom, f, fshift, fzoom] = PSDtz( IQ, Nfft, fs, fmax);
plot(fshift,10*log10(abs(fs*Pshift))); xlabel('f (Hz)'); ylabel('(dB)');
title('RX: PSD of IQ(n)'); grid; pause

figure;
subplot(211); plot(nn,real(IQ(nn)),'b.-'); grid; xlabel('n'); title('RX: I(n)');
subplot(212); plot(nn,imag(IQ(nn)),'r.-'); grid; xlabel('n'); title('RX: Q(n)'); pause
figure;
subplot(211); plot( nn, real(IQ(nn)),'b.-',kk,real(IQ(kk)),'bo','MarkerFaceColor','blue' ); xlabel('n'); title('RX: I(n)'); grid;
subplot(212); plot( nn, imag(IQ(nn)),'r.-',kk,imag(IQ(kk)),'ro','MarkerFaceColor','red' );  xlabel('n'); title('RX: Q(n)'); grid;
pause    
figure;
subplot(211); plot( n2, real(IQ(n2)),'b-',ns,real(IQ(ns)),'bo'); xlabel('n'); title('RX: I(n)'); grid;
subplot(212); plot( n2, imag(IQ(n2)),'r-',ns,imag(IQ(ns)),'ro');  xlabel('n'); title('RX: Q(n)'); grid;
pause    
figure; plot( real(IQ(n)),imag(IQ(n)),'b-',real(IQ(ns)),imag(IQ(ns)),'ro','MarkerFaceColor','red');
xlabel('I(n)'); ylabel('Q(n)'); title('RX: Q(n) = f( I(n) )'); grid; pause

figure;
Nshift=floor(K/2)+1; m = 1+Nshift : N-(K-Nshift);
subplot(121); plot( reshape(real(IQ(m)),K,(N-K)/K),'b'); xlabel('n'); title('RX: Eye diagram for I(n)'); grid;
subplot(122); plot( reshape(imag(IQ(m)),K,(N-K)/K),'r'); xlabel('n'); title('RX: Eye diagram for Q(n)'); grid; pause

figure;
Kend = min(20,length(IQk));
subplot(221); stem( real( IQk(1:Kend) ) ); grid; title('PSF <INPUT>:  Real(I(k))');
subplot(222); stem( imag( IQk(1:Kend) ) ); grid; title('PSF <INPUT>:  Imag(I(k))');
subplot(223); stem( real(IQkk(1:Kend) ) ); grid; title('PSF <OUTPUT>: Real(I(k))');
subplot(224); stem( imag(IQkk(1:Kend) ) ); grid; title('PSF <OUTPUT>: Imag(I(k))');
pause
