% lab20_ex_figures_TX.m is included in lab20_ex_pulse_shaping.m
% Figures in the transmitter

Ks = min( 20, length(IQk) );
k = 1 : Ks;
n = 1 : min( length(IQn), Ks*K );

% I(k), Q(k)
figure;
subplot(211); stem(real(IQk(k)),'b'); grid; xlabel('k'); title('TX: I(k)');
subplot(212); stem(imag(IQk(k)),'r'); grid; xlabel('k'); title('TX: Q(k)'); pause

% I0(n), Q0(n)
figure;
subplot(211); stem(real(IQ0(n)),'b'); grid; xlabel('n'); title('TX: I0(n)');
subplot(212); stem(imag(IQ0(n)),'r'); grid; xlabel('n'); title('TX: Q0(n)'); pause

% h_psf(n)
nz1=1+K+Mpsf-2*K; nz2 = nz1 + 4*K;
% figure; stem(hpsf); xlabel('n'); title('hpsf(n)'); grid; pause
        figure; stem(0:Npsf-1,hpsf); xlabel('n'); title('hpsf(n)'); grid; hold on;
        stem(0:K:Npsf-1,hpsf(1:K:Npsf),'filled','b'); pause

figure; plot(1:Npsf,hpsf,'k--',1+K:Npsf+K,hpsf,'b.-',1+2*K:Npsf+2*K,hpsf,'r-',...
        nz1,0,'bo',nz2,0,'bo'); xlabel('n'); title('3x hpsf(n)'); grid; pause
    
% I(n), Q(n) in TRANSMITTER
disp('TRANSMITTER');

IQ = IQn;

N = length(IQ); n=1:N; n2=1:round(N/2); ns = 1:K:N;
NN = min(N,Ks*K-(K-1)); nn=1:NN; kk = 1:K:NN;

figure;
subplot(211); plot(nn,real(IQ(nn)),'b.-'); grid; xlabel('n'); title('TX: I(n)');
subplot(212); plot(nn,imag(IQ(nn)),'r.-'); grid; xlabel('n'); title('TX: Q(n)'); pause

figure;
subplot(211); plot( nn, real(IQ(nn)),'b.-',kk,real(IQ(kk)),'bo','MarkerFaceColor','blue' ); xlabel('n'); title('TX: I(n)'); grid;
subplot(212); plot( nn, imag(IQ(nn)),'r.-',kk,imag(IQ(kk)),'ro','MarkerFaceColor','red' );  xlabel('n'); title('TX: Q(n)'); grid;
pause

figure;
subplot(211); stem( nn-1, real(IQ(nn)),'b'), xlabel('n'); title('I(n)'); grid; hold on;
stem(kk-1,real(IQ(kk)),'filled','b' );
subplot(212); stem( nn-1, imag(IQ(nn)),'r'), xlabel('n'); title('Q(n)'); grid; hold on;
stem(kk-1,imag(IQ(kk)),'filled','r' ); pause

figure;
subplot(211); plot( n2, real(IQ(n2)),'b-',ns,real(IQ(ns)),'bo'); xlabel('n');  title('TX: I(n)'); grid;
subplot(212); plot( n2, imag(IQ(n2)),'r-',ns,imag(IQ(ns)),'ro');  xlabel('n'); title('TX: Q(n)'); grid;
pause    
figure; plot( real(IQ(n)),imag(IQ(n)),'b-',real(IQ(ns)),imag(IQ(ns)),'ro','MarkerFaceColor','red');
xlabel('I(n)'); ylabel('Q(n)'); title('TX: Q(n) = f( I(n) )'); grid; pause

figure;
Nshift=floor(K/2)+1; m = 1+Nshift : N-(K-Nshift);
subplot(121); plot( reshape(real(IQ(m)),K,(N-K)/K),'b'); xlabel('n'); title('TX: Eye diagram for I(n)'); grid;
subplot(122); plot( reshape(imag(IQ(m)),K,(N-K)/K),'r'); xlabel('n'); title('TX: Eye diagram for Q(n)'); grid; pause

figure
Nfft = round(0.75*length(IQ)); Nfft = 2 ^ floor(log2(Nfft)); fmax = fs/4;
[P, Pshift, Pzoom, f, fshift, fzoom] = PSDtz( IQ, Nfft, fs, fmax);
plot(fshift,10*log10(abs(fs*Pshift))); xlabel('f (Hz)'); ylabel('(dB)');
title('TX: PSD of IQ(n)'); grid; pause
