% lab20_ex_rcos.m
% Raised cosine (RC) and square root RC (SRRC) pulse shaping filters (PSF)
clear all; close all;

psf = 'rcos';               % 'rcos', 'sqrt-rcos'
r = 0.5;                    % roll-off factor
Nsymb = 10;                 % number of samples per symbol, interpolation order
Ksymb = 4;                  % number of symbols per PSF filter 
Npsf = Ksymb*Nsymb;         % filter length
n = 0 : Npsf; Nc = Npsf/2;  % indexes of filter samples, index of the central sample

if( isequal( psf, 'rcos') ) % definition of raised cosine
    hpsf = sin(pi*(n-Nc)/Nsymb) ./ (pi*(n-Nc)/Nsymb) .* ...
           cos(pi*r*(n-Nc)/Nsymb) ./ (1-(2*r*(n-Nc)/Nsymb).^2);
    hpsf(Nc+1) = 1;   
    n0 = find( abs(1-(2*r*(n-Nc)/Nsymb).^2 ) < sqrt(eps) );
    hpsf(n0) = r/2 * sin(pi/(2*r));
elseif( isequal( psf, 'sqrt-rcos') ) % definition of sqrt of raised cosine
    n0 = find( abs(1-(4*r*(n-Nc)/Nsymb).^2) < 5*eps ), pause
    if( prod(size(n0)) > 0 ) disp('Div by 0. Change parameters'); end
    hpsf = 4*r/pi * ( cos(pi*(1+r)*(n-Nc)/Nsymb)+(Nsymb./(4*r*(n-Nc)) ) ...
           .* sin(pi*(1-r)*(n-Nc)/Nsymb) ) ./ (1-(4*r*(n-Nc)/Nsymb).^2);
    hpsf(Nc+1) = (1+r*(4/pi-1));   
end
hpsf = hpsf/Nsymb; % normalization

if(1) % Comparison with Matlab
   if( isequal( psf, 'rcos') ) type = 'normal'; else type = 'normal'; end    
   fs = 1; fcut = 1/(2*Nsymb)
   hpsf0 = firrcos( Npsf, fcut, r, fs,'rolloff',type); % MATLAB function
   error = max(abs(hpsf-hpsf0)), pause
end
