% lab20_ex_rcos_conv2x.m
% RC filter as a convolution of two SRRC filters
clear all; close all;

Nsymb = 20;                 % number of samples per symbol, interpolation order
Ksymb = 10;                 % number of symbols per PSF filter
r = 0.35;                   % rolloff factor
Npsf = Ksymb*Nsymb;         % PSF filter length

fs = 1; fcut = 1/(2*Nsymb)
hRC1  = firrcos( Npsf, fcut, r, fs,'rolloff','normal');
hSRRC = firrcos( Npsf, fcut, r, fs,'rolloff','sqrt');

hRC2 = conv(hSRRC,hSRRC);

N1 = length(hRC1); M1=(N1-1)/2; n1 = -M1:M1;
N2 = length(hRC2); M2=(N2-1)/2; n2 = -M2:M2;
plot(n1,hRC1,'r-',n2,hRC2,'b-'); grid; xlabel('n'); title('RC via SRRC');  

