%lab20_ex_text2states.m - example of text manipulation in Matlab
clear all; close all;

NBPS = 4;  % number of bits per symbol = log2( Nsymbols ), e.g. 4=log2(16)

% Out text to be coded and transmitted
text = 'Hello', % World! One, two, three, four, five, six, seven, eight, nine.',

% Text coding
bytes_str = dec2bin( text, 8 ),                                % text, bits of chars in rows 
bits = double( reshape( bytes_str',[ 8*length(text), 1])-'0'), % all bits in one column  
states = reshape( bits,[ NBPS, length(bits)/NBPS])',           % bits of symbols in rows.
numbers = bi2de( states,'left-msb' ),                          % symbol numbers in one col.

% Symbol transmitting and receiving

% Text decoding
states = de2bi( numbers,'left-msb' ),            % bits of symbols in rows         
bits = reshape( states',[ 8*length(text), 1]),   % all bits in one column  
bytes_str = reshape( bits, 8, length(bits)/8)',  % bits of letters in rows
ascii = bi2de( bytes_str, 'left-msb' ),          % ASCII codes of letters
disp( char(ascii') ),                            % text display
