% lab22_ex_ADCppm1.m
clear all; close all;

N = 64;                            % number of signal samples
k0 = 25;                           % frequency index of tested harmonic        
ppm = 10000e-6; cfo = 0.25;        % assumed ADC ppm error and CFO error
x  = exp( j*2*pi/N*k0*(0:N-1));                     % signal 1 well sampled
xe = exp( j*2*pi/N*( k0*(1+ppm)+cfo )* (0:N-1) );   % signal 2 wrong sampled
Xref = fft(x)/N;                   % spectrum of reference signal 1
Xe1  = fft(xe)/N;                  % spectrum of reference signal 2

for k=0:N-1                        % spectrum of signal 1 with DFT error
    Xe2(k+1) = sum( x .* exp( -j*2*pi/N*(k*(1-ppm)-cfo)*(0:N-1) ) )/N;
end
figure; plot(1:N,abs(Xref),'ro',1:N,abs(Xe1),'bo',1:N,abs(Xe2),'b*'); grid;
xlabel('k'); title('|X(k)|'); legend('Xref','Xe1','Xe2'); pause

for k=0:N-1                        % spectrum of signal 2 with DFT correction 
    Xcor(k+1) = sum( xe .* exp(-j*2*pi/N*(k/(1-ppm)+cfo)*(0:N-1) ) ) / N; 
end 
figure; plot(1:N,abs(Xref),'ro',1:N,abs(Xcor),'m*'); grid;
xlabel('k'); title('|X(k)|'); legend('Xref','Xcorected'); pause
