function [ CRC ] = CRCuniversal( Data, Polynomial, CRC, cFlag )
% Data       - input bit message
% Polynomial - used, with 1s on the most/least significant bits
% CRC        - initial CRC values in the shift buffer, all 1s or all 0s
% cFlag      - 0/1 complement flag: optional complement of last (P-1) input bits

P = length( Polynomial );              % polynomial length
Polynomial = Polynomial( 2 : P-1 );    % remove MSB and LSB 1s

% Optional complement of (P-1) last input bits
if( cFlag == 1 )
    Data(end-(P-2):end) = xor( Data(end-(P-2):end), ones(1,P-1) );
end

% CRC calculation - buffer shifting and data xor-ing 
% CRC,  % initial value
for i = 1 : length(Data)
    if( xor( CRC(1), Data(i) ) == 1)
        CRC = [ xor( Polynomial, CRC(2:end) ) 1 ];
    else
        CRC = [ CRC(2:end) 0 ];
    end
  % CRC, pause % in fig.23.21 order of bits is reversed
end