% lab23_ex_crc
% Testing CRC error protection

% Bit sequence to be coded
% N = 32; Bits = round( rand(1,N) );      % e.g. [ 1 1 0 ... 1 1 0 1];
Bits = [ 1 1 1 1 ]; N = length( Bits );   % our example

% Generating polynomials
 Polynomial =  [ 1 1 0 1 ];                         % Test - our example
%              x^8    +     x^2+ 1                  % CRC-8
%Polynomial = [  1 0 0 0 0 0 1 0 1  ];              % CRC-8
%               x^8 +  x^4+x^3+x^2 + 1              % CRC-8
%Polynomial = [  1 0 0 0 1  1  1  0  1  ];          % CRC-8
%           x^16+x^15          +          x^2 +1    % CRC-16-ITU
%Polynomial = [1 1 0 0 0 0 0 0 0 0 0 0 0 0 1 0 1];  % CRC-16-ITU
%            x^16  +  x^12     +    x^5   +    1    % CRC-16
%Polynomial = [1 0 0 0 1 0 0 0 0 0 0 1 0 0 0 0 1];  % CRC-16

P = length( Polynomial ); 

% Encoder and decoder demo with binary number division
disp('Easy encoder');
CRC = CRCeasy( [ Bits zeros(1,P-1)], Polynomial),
disp('Easy decoder');
CRC = CRCeasy( [ Bits CRC ], Polynomial ), pause  % should be [ 0 0 ... 0]

% Encoder and decoder with shift buffer
disp('Universal encoder');
CRC = CRCuniversal( [ Bits ], Polynomial, zeros(1,P-1), 0 ),
disp('Universal decoder');
CRC = CRCuniversal( [ Bits CRC ], Polynomial, zeros(1,P-1), 0 ), pause
