% Main script for the RDS decoder algorithms
% (c) 2001 Lieven Hollevoet, picmicro@hollie.tk

% Re-use of this code is hereby permitted, as long as
% my name and e-mail address are mentioned in the new
% version.

clear all
% Parity check matrix
check = [ 1 0 0 0 0 0 0 0 0 0;
   0 1 0 0 0 0 0 0 0 0;
   0 0 1 0 0 0 0 0 0 0;
   0 0 0 1 0 0 0 0 0 0;
   0 0 0 0 1 0 0 0 0 0;
   0 0 0 0 0 1 0 0 0 0;
   0 0 0 0 0 0 1 0 0 0;
   0 0 0 0 0 0 0 1 0 0;
   0 0 0 0 0 0 0 0 1 0;
   0 0 0 0 0 0 0 0 0 1;
   1 0 1 1 0 1 1 1 0 0;
   0 1 0 1 1 0 1 1 1 0;
   0 0 1 0 1 1 0 1 1 1;
   1 0 1 0 0 0 0 1 1 1;
   1 1 1 0 0 1 1 1 1 1;
   1 1 0 0 0 1 0 0 1 1;
   1 1 0 1 0 1 0 1 0 1;
   1 1 0 1 1 1 0 1 1 0;
   0 1 1 0 1 1 1 0 1 1;
   1 0 0 0 0 0 0 0 0 1;
   1 1 1 1 0 1 1 1 0 0;
   0 1 1 1 1 0 1 1 1 0;
   0 0 1 1 1 1 0 1 1 1;
   1 0 1 0 1 0 0 1 1 1;
   1 1 1 0 0 0 1 1 1 1;
   1 1 0 0 0 1 1 0 1 1];

% Load data

  %load FM_Radio_RDS_Costas_long_fast.txt;
  %data = FM_Radio_RDS_Costas_long_fast.';
  %clear FM_Radio_RDS_Costas_long_fast; %data = data(2:2:end);

  load FM_Radio_RDS.txt;
  data = FM_Radio_RDS.';
  clear FM_Radio_RDS;

% data=data(13:end); % TZ test

lengte = (length(data)-130);
disp('Length of the data is (#bits):');
disp(lengte);
disp('Processing data... Please be patient.');

naam = 'xxxxxxxx';
text1 = 'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx';
text2 = 'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx';

% Syndroms
sA =  [1 1 1 1 0 1 1 0 0 0];
sB =  [1 1 1 1 0 1 0 1 0 0];
sCa = [1 0 0 1 0 1 1 1 0 0];
sCb = [1 1 1 1 0 0 1 1 0 0];
sD =  [1 0 0 1 0 1 1 0 0 0];

% Search for syndroms 
% Bit-slip detection (for synchronisation)
loper = 1;

while (loper < lengte)
   resultaat = syndrome(loper, data, check);
   if (resultaat == sA)
      % If you arrive here, loper contains the offset for the 
      % start of block A. So block B should be at position loper+26 -> check it...
      resultaat = syndrome(loper+26, data, check);
      if (resultaat == sB)                          % Block B found
         resultaat = syndrome (loper + 52, data, check);
         if (resultaat == sCa)                      % Block Ca found
            resultaat = syndrome (loper + 78, data, check);
            if (resultaat == sD)                    % Complete group read
               [naam text1 text2] = process(loper, data, naam, text1, text2);                % Verwerk
               loper = loper + 103;                 % increment loper
            end
         elseif (resultaat == sCb)                  % Block Cb
            resultaat = syndrome (loper + 78, data, check);
            if (resultaat == sD)                    % Complete group read
               [naam text1 text2] = process(loper, data, naam, text1, text2);                % Verwerk
               loper = loper + 103;
            end
         end
      end
   end
   loper = loper + 1;
end

% Display results
% if you want to see the complete algorithm execution, enable the disp commands in the process routine
% (file: process.m, last 4 lines)
fprintf('\n');
disp(naam);
disp(text1);
%disp(text2);


              
   