function y = awgnTZ( x, SNR, dummy )
% Additive White Gaussian Noise with specified SNR
% Alternative for Matlab: y = awgn( x, SNR, 'measured' );
N = length(x);
if( isreal(x) ) % REAL_VALUE SIGNAL #######################################
   if(0)   % approximate
      scale = sqrt( sum( x.*x ) / (N*10^(SNR/10)) );
      y = x + scale * randn(1,N);
   else    % exact
      r = randn(1,N);
      scale = sqrt( sum( x.*x ) / sum( r.*r ) / (10^(SNR/10)) );
      y = x + scale * r;
   end   
else            % COMPLEX-VALE SIGNAL #####################################
   if(1)  % approximate 
      scale = sqrt( sum( x.*conj(x) ) / (2 * N*10^(SNR/10)) );
      y = x + scale * (randn(1,N)+j*randn(1,N));
   else   % 
      r = randn(1,N) + j*rand(1,N);
      scale = sqrt( sum(x.*conj(x)) / sum(r.*conj(r)) / (10^(SNR/10)) );
      y = x + scale * r;
   end    
end