function [P, Pshift, Pzoom, f, fshift, fzoom] = psdTZ( x, Nfft, fs, fmax)

x = x(:);                                    % change to vertical
Nx = length( x ); nc = round(Nx/2);          % find central point
df = fs/Nfft;                                % df - step in frequency
f = df * (0 : 1 : Nfft-1)';                  % frequency axis [ 0, fs ]
fshift = df * (-Nfft/2 : 1 : Nfft/2-1)';     % frequency axis [ -fs/2, fs/2 ]
w = kaiser(Nfft,10);                         % window function used
X = fft( x(nc-Nfft/2:nc+Nfft/2-1).*w );      % FFT of windowed signal
P = 2*X.*conj(X)/(fs*sum(w.^2));             % Power Spectral Density (dB/Hz)
Pshift = fftshift( P );                      % circularly shifted PSD

indx = find(f >= fmax); K = indx(1)-1;       % fragment of the central part
Pzoom = Pshift( Nfft/2+1-K : Nfft/2+1+K );   %
fzoom = fshift( Nfft/2+1-K : Nfft/2+1+K );   %


